/*****************************************************************************
* Copyright (c) Future Technology Devices International 2014
* propriety of Future Technology devices International.
*
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by FTDI. 
* FTDI accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file                           Sender_Enhanced_Flow_Ctl.ino
* @brief                          Sketch to demonstrate enhanced RS485 functionality.
								  Tested platform version: Arduino 1.0.4 and later
* @version                        0.1.0
* @date                           2014/10/01
*
*/


/* Arduino standard includes */
#include "SPI.h"
#include "Wire.h"


#include "FT_VI800A_N485U.h"

FT_VI800A VI800A;


void setup()
{
	/* Initialize serial print related functionality */
	Serial.begin(9600);
    Serial.println("\n\r\n\r-----------Sender_Enhanced_Flow_Ctl.ino--------------");
	

	VI800A.Init(FT_N485U_CS, 9600,FT_VI800A_Forced_Parity_Zero, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
	
	VI800A.SetFlowControl(FT_VI800A_No_Flow);
	VI800A.EnableFIFO(FT_VI800A_Enable);
	VI800A.clearFIFO();
}

uint8_t command;
char incommingData;

void loop()
{
   if(Serial.available() > 0)
   {
		command = Serial.read();
		if(command == 'q'){
			VI800A.SetDataFormat(FT_VI800A_Forced_Parity_One, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
			delay(3);
			VI800A.Write(command);
			Serial.print("Sent Address Byte: ");
			Serial.println((char)command);
			delay(3);
			VI800A.SetDataFormat(FT_VI800A_Forced_Parity_Zero, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
		}
		else if(command == 'w'){
			VI800A.SetDataFormat(FT_VI800A_Forced_Parity_One, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
			delay(3);
			VI800A.Write(command);
			Serial.print("Sent Address Byte: ");
			Serial.println((char)command);
			delay(3);
			VI800A.SetDataFormat(FT_VI800A_Forced_Parity_Zero, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
		}
		else{
			VI800A.Write(command);
			
			//Uncomment the following two lines to print out the sent character.  However, the overhead to print the following two message will most likely be longer than 4 character time frame to hit the stale data interrupt
			//Serial.print("Sent: ");
			//Serial.println((char)command);
		}
		
		
   }

   

   if(VI800A.isDataInReceiver()){
		incommingData = VI800A.Read();
		Serial.print("Received: ");
		Serial.println((char)incommingData);
	}
	
}

































