/*****************************************************************************
* Copyright (c) Future Technology Devices International 2014
* propriety of Future Technology devices International.
*
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by FTDI. 
* FTDI accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file                           Receiver_SW_Flow_Ctl.ino
* @brief                          Sketch to demonstrate application software flow control functionality for VI800A-TTLU add-on module.
								  Tested platform version: Arduino 1.0.4 and later
* @version                        1.0.0
* @date                           2014/10/01
*
*/


/* Arduino standard includes */
#include "SPI.h"
#include "Wire.h"


#include "FT_VI800A_TTLU.h"

FT_VI800A VI800A;

void setup()
{	
	/* Initialize serial print related functionality */
	Serial.begin(9600);
    Serial.println("\n\r\n\r-----------Receiver_SW_Flow_Ctl.ino--------------");
	
	VI800A.Init(FT_TTLU_CS,9600,FT_VI800A_No_Parity, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
	VI800A.SetFlowControl(FT_VI800A_No_Flow);
	VI800A.EnableFIFO(FT_VI800A_Enable);
}

char incommingData, XON=0x01,XOFF=0x02;
uint8_t haltlvl=16, resumelvl=8, curFIFOlvl, XONSent=0, XOFFSent=0;

void loop()
{
	if(VI800A.isDataInReceiver()){
		incommingData = VI800A.Read();
		curFIFOlvl = VI800A.GetReceiveFIFOFillLevel();
		if(curFIFOlvl>haltlvl){
			if(XOFFSent==0){
				VI800A.Write(XOFF);
				XOFFSent=1;
				XONSent=0;
			}
		}
		else if(curFIFOlvl<resumelvl){
			if(XONSent==0){
				VI800A.Write(XON);
				XONSent=1;
				XOFFSent=0;
			}
		}
		
		Serial.print("Received: ");
		Serial.print(incommingData);
		Serial.print(" ");
		Serial.print("FIFO fill level: ");
		Serial.println(VI800A.GetReceiveFIFOFillLevel());
		delay(100);
	}
}
















